
;librairie libcmt.lib
;	includelib  C:\PROGRA~1\MI9D60~1\Lib\strsafe.lib
;	includelib  C:\PROGRA~1\MICROS~1.0\VC\lib\libcmt.lib
;extern c _FPinit:dword	; to load floating point library
;avoid the R6002 floating point not loaded error 

; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; -------------------------------------------------------------------
      ; Les fichiers inclus ii ,AUCUN .lib c'est au programme utilisateur
      ;	de les fournir
      ; -------------------------------------------------------------------
       include \masm32\include\windows.inc
	include \masm32\include\kernel32.inc
       include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
	include \masm32\include\comctl32.inc
       include \masm32\include\masm32.inc
	include \masm32\include\strsafe.inc
	include \sdkrc7\translate.inc
	include float.sdk
      ;  include macros.txt	

      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------

      ; 
      ;exemples de definitions externes
       	EXTERNDEF f_callback :PROTO
      ; 	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
      ; 	EXTERNDEF PoriginePile:DWORD			


	InsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
		lbl:
	ENDM

	PuPo MACRO M1, M2
		push M2
		pop  M1
	ENDM

	return MACRO arg
		mov eax, arg
		ret
	ENDM
	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM

	
	ZEROLOCALES MACRO dernierelocale:REQ
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B		
	ENDM	


	;=================
	; Local prototypes
	;=================
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	X_TO_Y_BYLOG  PROTO    ; .. x**y by logarithms
	E_TO_Y	PROTO
	RAD_TO_DEG  PROTO
	InterrogeFPUcontrole PROTO 
	InterrogeFPUetat PROTO

	CreationBouton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	CreationEtiquette PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	CreationBoiteEdition PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	InterrogeFPUetat PROTO 
	SauvePile PROTO :DWORD
	TopXY PROTO   :DWORD,:DWORD
	Paint_Proc PROTO :DWORD,:DWORD
	f_window PROTO 
	PourMille	PROTO :DWORD,:DWORD
.const	
;-------------------------------------------
;      STRSAFE_FILL_BYTE(0xFF)     0x000000FF  // bottom byte specifies fill pattern
STRSAFE_IGNORE_NULLS   equ   <000000100h>
STRSAFE_FILL_BEHIND_NULL   equ   <000000200h>
STRSAFE_FILL_ON_FAILURE   equ   <000000400h>
STRSAFE_NULL_ON_FAILURE   equ   <000000800h>
STRSAFE_NO_TRUNCATION   equ   <000001000h>
STRSAFE_VALID_FLAGS   equ   <0000000FFh OR  STRSAFE_IGNORE_NULLS OR  STRSAFE_FILL_BEHIND_NULL OR \
            		STRSAFE_FILL_ON_FAILURE OR  STRSAFE_NULL_ON_FAILURE OR  STRSAFE_NO_TRUNCATION>		
Show_Float equ 0
Show_Hexa  equ 1
Show_Expo  equ 2
Show_Deci  equ 3
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	Xfenetre = 600                         ;
	Yfenetre = 470 			          ;	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
	XresolutionDeBase  = 800	          ;a ne pas changer
	YresolutionDeBase = 600	
	
SAVESTACK STRUCT
	State		dd 0
	AdrReturn dd 0 	
	number dd 0
	buffer dd 300 dup (?)
SAVESTACK ENDS

	;usage	 mov resultat,HAUTEUR( Rct)
	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom                 ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top	  			; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right       ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left      ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM			
	PUBLIC savestack

   .data	

savestack SAVESTACK <>
	sznextstep   db "Next Step",0
	PrintfFloat0 db "%.16f",0		;affichage float
	PrintfFloat1 db "%Xh",0
	PrintfFloat2 db "%e",0
	PrintfFloat3 db "%d",0
	;-----------------------------------------
	dwImageRatio	DQ +0.0 
	ImageLong		dd 20
	ImageHaut		dd 20
	titre 		db "titre",0
	SauveFpu  		FLOATING_SAVE_AREA <>	
	szDisplayName 	db "Floating Processor Unit",0
	szClassName   	db  "NombresFlottant",0
	Sortie 		DB "E:\asm\math\wintrg\Float.sav",0
	PresqueZero 	db "-0.000000e+647",0		;show blank instead of this
	PPresqueZero	db "0.000000e+647",0		;empty register
	strzero 		db 0,0
	paszero		db "-0.000000e+648",0		;controle condition
	
	CommandLine   	dd 0
	hWnd         	dd 0
	hInstance     	dd 0
	hStatus       	dd 0
	hToolBar     	dd 0
	Xresolution   	dd 0
	Yresolution  	dd 0
	Hbutton		dd 0
	Hcontrol     	dd 16 DUP(0)
	Hetat			dd 16 DUP(0)
	sept 			DQ +7.0
	six 			DQ +6.0
	cinq 			DQ +5.0
	quatre 		DQ +4.0
	trois 		DQ +3.0
	deux 			DQ +2.0
	unite 		DQ 1.0E0
	zero 			DQ 0.0 ;0.1E-5
;
	FPUDATA0   		DQ 0
	FPUDATA1   		DQ 0
	FPUDATA2   		DQ 0
	FPUDATA3   		DQ 0
	FPUDATA4   		DQ 0
	FPUDATA5   		DQ 0
	FPUDATA6   		DQ 0
	FPUDATA7   		DQ 0
	AfficheRegistreFPU	 	DB " Value of numbers in stack ",0
	AfficheRegistreControl	db " Control Register ",0
	AfficheEtatFPU  	 	db " State Register ",0
	controltext0 		db " Invalid Operation ",0
	controltext1 		db " Denormalized ",0
	controltext2 		db " Zero divide ",0
	controltext3 		db " Overflow ",0
	controltext4 		db " Underflow ",0
	controltext5 		db " Precision ",0
	controltext6 		db " reserved ",0
	controltext7 		db " reserved ",0
	controltext8 		db " B8 Precision control",0
	controltext9		db " 53 bits +B8 =64 bits",0
	controltext10 		db " B10 Round Down ",0
	controltext11 		db " Up + B10=Troncate",0
	controltext12 		db " reserved ",0
	controltext13 		db " reserved ",0
	controltext14 		db " reserved ",0
	controltext15 		db " reserved ",0

	EtaTtexte0 			db " Invalid Operation ",0
	EtaTtexte1 			db " Denormalized ",0
	EtaTtexte2 			db " Zero divide ",0
	EtaTtexte3 			db " Overflow ",0
	EtaTtexte4 			db " Underflow ",0
	EtaTtexte5 			db " Precision ",0
	EtaTtexte6 			db " Stack Fault ",0
	EtaTtexte7 			db " Exception Flag ",0
	EtaTtexte8 			db " C0 Condition Flag ",0
	EtaTtexte9 			db " C1 stack overflow",0
	EtaTtexte10 		db " C2 ",0
	EtaTtexte11 		db " B11 0 of Stack ptr ",0  ;content value of STACK POINTER
	EtaTtexte12 		db " B12 1 of stack ptr ",0
	EtaTtexte13 		db " B13 2 of stack ptr",0
	EtaTtexte14 		db " C3 ",0
	EtaTtexte15 		db " Busy ",0
	;

	stackFPU0 			db "ST(0)",0
	stackFPU1 			db "ST(1)",0
	stackFPU2 			db "ST(2)",0
	stackFPU3 			db "ST(3)",0
	stackFPU4 			db "ST(4)",0
	stackFPU5 			db "ST(5)",0
	stackFPU6 			db "ST(6)",0
	stackFPU7 			db "ST(7)",0
	stackPoint			db "Number of datas in stack: ",0
	EtiRegCont			db "Rounding control : ",0
	EtiPreCont			db "Precision control: ",0
	HstackPoint			dd 0
	Hround			dd 0
	Hprecision			dd 0
	Hedit0 			dd 0
	Hedit1 			dd 0
	Hedit2 			dd 0
	Hedit3 			dd 0
	Hedit4 			dd 0
	Hedit5 			dd 0
	Hedit6 			dd 0
	Hedit7 			dd 0

; Definition of constant e
E               DT      4000ADF85458A2BB4A9BH

; Constants are defined in extended precision format
	ONE_80          DT      180.0   ; 180
	valeur          DQ       60.0
	radian60Deg     DQ      1.0472
	Float 	  DQ   0  ;QWORD  8 bytes , Double-precision floating point
	Tampon	  Db 19 dup (0)
	sortie 	  Db 19 dup (0)
	Angle		  DQ 180.0
	resultat	dd 0
	plusdword	dd 0
	
Message000 		DB "Insert your code in commande.inc ",0Dh,0Ah
			Db "         '.elseif wParam == 52' ",0Dh,0Ah
			Db " ligne 50 ",0
	Affichage 	  DW 50 DUP(0)
	phrase 	db 30 dup(0)
	etatround     word 0
	etatcontrol   word 0
	;----- ++ essai
	DeuxPI REAL8  6.2831853071795864 ;0401921fb60000000r	;	
	QuaranteNeuf	REAL8 49.0
	ppszDestEnd dd 0    ;pointe sur le zero en fin de chaine copier
;screen position data
	xcol0 dd 10
	xcol1 dd 60	
	xcol2 dd 270
	xcol3 dd 430
	StartY dd 30
	Leti  dd 150
	heti  dd  20
	marge dd 5
	ybutton dd 0
	xbutton dd 0		
	contWord dw 27fh

    .code


;################################################################
f_window PROC 
			Local  retour:DWORD
	mov retour,1
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

 Findef_window:
         mov eax,retour
         ret
f_window endp

;################################################################


; #########################################################################

WinMain proc  hInst:DWORD,hPrevInst:DWORD,CmdLine :DWORD,CmdShow:DWORD
	LOCAL wc   :WNDCLASSEX
	LOCAL msg  :MSG
	Local screen:RECT
	LOCAL largFen  :DWORD
	LOCAL HautFen  :DWORD
	LOCAL Xpos  :DWORD
	LOCAL Ypos  :DWORD
	local retour:DWORD
	ZEROLOCALES retour

	invoke InitCommonControls
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	mov hInst,eax

	;==================================================
	; Fill WNDCLASSEX structure with required variables
	;==================================================

	mov wc.cbSize,         sizeof WNDCLASSEX
	mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS
	mov wc.lpfnWndProc,    offset WndProc        ;prend un nom indifferent
	mov wc.cbClsExtra,     NULL
	mov wc.cbWndExtra,     NULL
	PuPo wc.hInstance,      hInst   ;<< NOTE: macro not mnemonic
	mov wc.hbrBackground,  COLOR_BTNFACE+1
	mov wc.lpszMenuName,   NULL
	mov wc.lpszClassName,  offset szClassName
	invoke LoadIcon,hInst,500    ; icon ID
	mov wc.hIcon,          eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov wc.hCursor,        eax
	mov wc.hIconSm,        0

	invoke RegisterClassEx, ADDR wc
	
	;---------------------------------------------------------------------------
	;keep sizes with differents screen resolutions
	;----------------------------------------------------------------------------
	invoke  SystemParametersInfo,SPI_GETWORKAREA,NULL,addr screen,NULL		
	mov Xresolution,LARGEUR(screen)
	invoke   PourMille,Xresolution,750
	mov largFen,eax                            ;resolution ?

	mov Yresolution,HAUTEUR(screen)
	invoke   PourMille,Yresolution,900
	mov HautFen,eax

	;================================
	; Centre window at following size
	;================================


	invoke TopXY,largFen,Xresolution
	mov Xpos, eax

	invoke TopXY,HautFen,Yresolution
	mov Ypos, eax
	
	invoke CreateWindowEx,WS_EX_LEFT,
				ADDR szClassName,
				ADDR szDisplayName,
				WS_OVERLAPPEDWINDOW,
				Xpos,Ypos,largFen,HautFen,
				NULL,NULL,
				hInst,NULL
	mov   hWnd,eax

	invoke LoadMenu,hInst,600  ; menu ID
	invoke SetMenu,hWnd,eax

	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd

	;===================================
	; Loop until PostQuitMessage is sent
	;===================================

	StartLoop:
	invoke GetMessage,ADDR msg,NULL,0,0
	cmp eax, 0
	je ExitLoop
	invoke TranslateMessage, ADDR msg
	invoke DispatchMessage,  ADDR msg
	jmp StartLoop
	ExitLoop:

	return msg.wParam

WinMain endp

; #########################################################################

WndProc proc PRIVATE hWndParent:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	LOCAL caW   :DWORD
	LOCAL caH   :DWORD
	LOCAL hDC   :DWORD
	Local client:RECT
	local hauteur:DWORD,largeur	
	LOCAL Rct   :RECT
	LOCAL tbb   :TBBUTTON
	LOCAL Tba   :TBADDBITMAP
	LOCAL Ps    :PAINTSTRUCT
	Local index:DWORD,theta
	Local PasseQword:REAL8
	Local retour:DWORD
	ZEROLOCALES retour

	InsTxt tbSelect,"You have selected"

	.if uMsg == WM_COMMAND
		HIWORD wParam		;evenements des listbox ,combo sont ici
		mov edx,eax		;exemple :TCN_SELCHANGE
		LOWORD wParam		;IDentificateurs de  commandes eax
		mov ebx,lParam	; handle du controle
		;suite
		.if edx == 0 && ebx == 0	
			.if eax == 1000
				invoke PostMessage,hWndParent,WM_CLOSE,NULL,NULL
				return 0				
			.elseif eax == 1001				
				invoke f_callback
				return 0				
			.endif
		.endif
		.if ebx == Hbutton
			.if savestack.State != 0
				invoke f_callback	
			.endif
			return 0
		.endif			
	.elseif uMsg == WM_CREATE

		;----------------------
		; Create the status bar
		;----------------------

		invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or \
					SBS_SIZEGRIP,0, hWndParent, 200
		mov hStatus, eax
	;-------- calculer les dimensions d'encombrements en % --------------------------
	invoke GetWindowRect,hStatus,addr Rct
	mov hauteur,HAUTEUR(Rct)
	invoke GetClientRect,hWndParent,addr client
	mov eax,HAUTEUR(client)
	sub eax,hauteur			;enlever la hauteur de la status
	mov hauteur,eax
	mov largeur,LARGEUR(client)
	;hauteur d'une etiquette         20/600 33/1000
	invoke   PourMille,Yresolution,33
	mov heti,eax
	;----- largeur d'tiquette ------- 150/800  187/1000
	invoke   PourMille,Xresolution,187
	mov Leti,eax
	;------ xcol0 ----- 10 /800  12/1000
	invoke   PourMille,Xresolution,12
	mov xcol0,eax
	;------ xcol1 ----- 60 /800  75/1000
	invoke   PourMille,Xresolution,75
	mov xcol1,eax
	;------ xcol2 ----- 270 /800  337/1000
	invoke   PourMille,Xresolution,337
	mov xcol2,eax
	;------ xcol3 ----- 430 /800  537/1000
	invoke   PourMille,Xresolution,537
	mov xcol3,eax									
	;------ StartY ----- 30 /600  50/1000
	invoke   PourMille,Yresolution,50
	mov StartY,eax										
	;------ marge ----- 5 /800  6/1000
	invoke   PourMille,Xresolution,6
	mov marge,eax											
	;-----------------------
	; create users control
	;------------------------
	;------------------------ enttes des colonnes ----------------------------
	invoke CreationEtiquette ,addr AfficheRegistreFPU,xcol1,StartY,200,heti,hWndParent,NULL
	invoke CreationEtiquette ,addr AfficheRegistreControl,xcol2,StartY,Leti,heti,hWndParent,NULL
	invoke CreationEtiquette ,addr AfficheEtatFPU,xcol3,StartY,Leti,heti,hWndParent,NULL
	; affiche les bits du registre de controle col1
	mov ebx,StartY
	add ebx,heti
	add ebx,marge	
	invoke CreationEtiquette ,addr controltext0,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[0],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext1,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[4],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext2,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[8],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext3,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[12],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext4,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[16],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext5,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[20],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext6,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[24],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext7,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[28],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext8,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[32],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext9,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[36],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext10,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[40],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext11,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[44],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext12,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[48],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext13,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[52],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext14,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[56],eax
	add ebx,heti
	invoke CreationEtiquette ,addr controltext15,xcol2,ebx,Leti,heti,hWndParent,NULL
	mov Hcontrol[60],eax
	
;-----------------------------------------------------------------------------------
;--------------- seconde colonne ----------------------------------------------------
	mov ebx,StartY
	add ebx,heti
	add ebx,marge
	invoke CreationEtiquette ,addr EtaTtexte0,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[0],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte1,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[4],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte2,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[8],eax
	add ebx,heti
	;stackfaut EtaTtexte3 (0 a 15)
	invoke CreationEtiquette ,addr EtaTtexte3,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[12],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte4,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[16],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte5,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[20],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte6,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[24],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte7,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[28],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte8,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[32],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte9,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[36],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte10,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[40],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte11,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[44],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte12,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[48],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte13,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[52],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte14,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[56],eax
	add ebx,heti
	invoke CreationEtiquette ,addr EtaTtexte15,xcol3,ebx,Leti,heti,hWndParent,NULL
	mov Hetat[60],eax
;
;----------------------- colonne 0 -------------------------------------------
	mov ebx,StartY
	add ebx,heti
	add ebx,marge	
	invoke CreationEtiquette ,addr stackFPU0,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit0,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU1,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit1,eax
	add ebx,heti
	add ebx,marge	
	invoke CreationEtiquette ,addr stackFPU2,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit2,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU3,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit3,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU4,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit4,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU5,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit5,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU6,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit6,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr stackFPU7,xcol0,ebx,40,heti,hWndParent,NULL
	invoke CreationBoiteEdition,NULL,xcol1,ebx,200,heti,hWndParent,NULL
	mov Hedit7,eax
	add ebx,heti
	add ebx,marge		
	;--------------- ---------------------------------------
	invoke CreationEtiquette ,addr stackPoint,xcol0,ebx,240,heti,hWndParent,NULL
	mov HstackPoint,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr EtiRegCont,xcol0,ebx,240,heti,hWndParent,NULL
	mov Hround,eax
	add ebx,heti
	add ebx,marge		
	invoke CreationEtiquette ,addr EtiPreCont,xcol0,ebx,240,heti,hWndParent,NULL
	mov Hprecision,eax
	add ebx,heti
	add ebx,marge		
	;create the buttom
	;	ybutton dd 0
	;xbutton dd 0
	;------ ybutton ----- 395 /600  658/1000
	invoke   PourMille,Yresolution,658
	mov ybutton,eax
	;------ ybutton ----- 200 /800  250/1000
	invoke   PourMille,Xresolution,250
	mov xbutton,eax	
														
	invoke CreationBouton,addr sznextstep,xbutton,ybutton,Leti,25,hWndParent,500	
	mov Hbutton,eax		
		
		
		
;------------------------------ lance le proc ------------------------------------------
		;invoke PostMessage,hWndParent,WM_COMMAND,1001,NULL
		;return 0
		;autorise l'appel de la callback par bouton
		mov savestack.State,1

	.elseif uMsg == WM_SIZE

		invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0
		PuPo caW, lParam[0]  ; client area width
		PuPo caH, lParam[2]  ; client area height
		invoke GetWindowRect,hStatus,ADDR Rct
		mov eax, Rct.bottom
		sub eax, Rct.top
		sub caH, eax
		invoke MoveWindow,hStatus,0,caH,caW,caH,TRUE
		return 0
		
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWndParent,ADDR Ps
		mov hDC, eax
		invoke Paint_Proc,hWndParent,hDC
		invoke EndPaint,hWndParent,ADDR Ps
		return 0

	;.elseif uMsg == WM_CLOSE
		;InsTxt TheText,"Please Confirm Exit"
		;invoke MessageBox,hWndParent,ADDR TheText,ADDR szDisplayName,MB_YESNO
		;.if eax == IDNO
		;	return 0
		;.endif
		invoke DestroyWindow,hWndParent
		return 0
	.elseif uMsg == WM_DESTROY		
		invoke PostQuitMessage,NULL
		return 0 
	.endif

	invoke DefWindowProc,hWndParent,uMsg,wParam,lParam

	ret

WndProc endp

; ########################################################################

TopXY proc PRIVATE wDim:DWORD, sDim:DWORD

	shr sDim, 1      ; divide screen dimension by 2
	shr wDim, 1      ; divide window dimension by 2
	mov eax, wDim    ; copy window dimension into eax
	sub sDim, eax    ; sub half win dimension from half screen dimension

	return sDim

TopXY endp

; ########################################################################

Paint_Proc proc PRIVATE hWndParent:DWORD, hDC:DWORD

	LOCAL caW :DWORD
	LOCAL caH :DWORD
	LOCAL tbH :DWORD
	LOCAL sbH :DWORD
	LOCAL Rct :RECT

	invoke GetClientRect,hWndParent,ADDR Rct
	PuPo caW, Rct.right
	PuPo caH, Rct.bottom

	invoke GetWindowRect,hToolBar,ADDR Rct
	mov eax, Rct.bottom
	sub eax, Rct.top
	mov tbH, eax

	invoke GetWindowRect,hStatus,ADDR Rct
	mov eax, Rct.bottom
	sub eax, Rct.top
	mov sbH, eax

	mov eax, caH
	sub eax, sbH
	mov caH, eax

	mov Rct.left, 0
	PuPo Rct.top, tbH
	PuPo Rct.right, caW
	PuPo Rct.bottom, caH

	invoke DrawEdge,hDC,ADDR Rct,EDGE_SUNKEN,BF_RECT

	return 0
Paint_Proc endp

;################################################################

DEG_TO_RAD      PROC   PRIVATE
; Convert entry value in ST(0) to radian measure
;
; On entry:
;         ST(0) = value in degrees
; On exit:
;         ST(0) = value converted to radians
;
; Formula:
;         r = d * (pi/180)
;
; where r = angle in radian, d = angle in degrees
;

;                       ;    ST(0)    |    ST(1)   |    ST(2)
			;      d      |  --------  |  -------- |
	FLD     ONE_80
			;     180     |     d      |
	FLDPI           ;    pi       |    180     |     d     |
		call SauvePile ; inspect the FPU

	FDIV    ST,ST(1);  pi/180     |    180     |     d     |

		call SauvePile ; inspect the FPU

	FSTP    ST(1)   ;  pi/180     |     d      |

	FMUL    ST,ST(1);     r       |     d      |
	FSTP    ST(1)   ;     r       |  --------- |

; ST(0) now holds entry value in radian
	RET
DEG_TO_RAD      ENDP
;################################################################

;****************************************************************
;                      radians-to-degrees
;****************************************************************
RAD_TO_DEG      PROC    
; Convert entry value in ST(0) to degrees
;
; On entry:
;         ST(0) = value in radian
; On exit:
;         ST(0) = value converted to degrees
;
; Formula:
;         d = r * (180/pi)
;
; where r = angle in radian, d = angle in degrees
;
;                       ;    ST(0)    |    ST(1)   |    ST(2)
	; en pile       ;      rad    | ---------- | --------- |
	FLDPI           ;      pi     |    rad     | --------- |Pushes a constant onto the stack
	FLD     ONE_80  ;     180     |     pi     |     rad   |
	FDIV    ST,ST(1);  180/pi     |     pi     |     rad   |
	FSTP    ST(1)   ;  180/pi     |     rad    | --------- | ST to memory location or register
	FMUL    ST,ST(1);     deg     |     rad    | --------- | multiplie
	FSTP    ST(1)   ;     deg     |  --------  |		   ST to memory location or register
; ST(0) now holds entry value in degrees
	RET
RAD_TO_DEG      ENDP

; #########################################################################
CreationEtiquette proc PRIVATE lpText:DWORD,PosX:DWORD,PosY:DWORD,Longueur:DWORD,Hauteur:DWORD,\
			hWndParent:DWORD,Hmenu:DWORD
;Hmenu nombre dans WM_COMMAND .elseif wParam == Hmenu
;pour les Etiquettes
	InsTxt statClass,"STATIC"

	invoke CreateWindowEx,WS_EX_STATICEDGE,
		ADDR statClass,lpText,
		WS_CHILD or WS_VISIBLE or SS_LEFT,
		PosX,PosY,Longueur,Hauteur,hWndParent,Hmenu,hInstance,NULL

	ret

CreationEtiquette endp
; #########################################################################

CreationBoiteEdition proc PRIVATE szMsg:DWORD,PosX:DWORD,PosY:DWORD,
		Longueur:DWORD,Hauteur:DWORD,hWndParent:DWORD,hMenu:DWORD
;Hmenu nombre dans WM_COMMAND .elseif wParam == Hmenu


	InsTxt GenreClass,"EDIT"
; GenreClass pourrait etre ....
;ToolClass      db  'ToolbarWindow32',0
;StatClass      db  'msctls_statusbar32',0
;TabClass       db  'SysTabControl32',0
;InsTxt   lstBox,   "LISTBOX"
;InsTxt   cmbBox,   "COMBOBOX"
;InsTxt statClass,  "STATIC"        etiquette
;        btnClass      db "BUTTON",0
;    InsTxt EditMl,"RICHEDIT"
; et plus.........


	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR GenreClass,szMsg,\
		WS_VISIBLE or WS_CHILDWINDOW or  ES_AUTOHSCROLL or ES_NOHIDESEL,\
		PosX,PosY,Longueur,Hauteur,hWndParent,hMenu,hInstance,NULL

	ret

CreationBoiteEdition endp
; ########################################################################

;################################################################
InterrogeFPUcontrole PROC PRIVATE uses esi edi ebx
	Local controle:WORD
	Local BitTest:DWORD
	FSTCW controle
	xor eax,eax
	mov ax,controle

	mov ecx,16
	@@:
	push ecx
	dec  ecx    ;Numero du bit de 0 a 15
	xor edx,edx
	mov dx,1
	rol dx,cl
	mov BitTest,edx
	pop ecx
	push ecx
	mov eax,ecx
	dec eax
	mov ecx,4
	mul ecx	;ebx pointe offset du handle d'etiquette
	mov ebx,eax
	mov edx,BitTest

	test controle,dx
	jnz visibleFPUcontrole
		mov edx,Hcontrol[ebx]
		invoke ShowWindow,edx,SW_HIDE ;SW_SHOWDEFAULT
		jmp boucleFPUcontrole
	visibleFPUcontrole:
		mov edx,Hcontrol[ebx]
		invoke ShowWindow,edx,SW_SHOWDEFAULT ;SW_SHOWDEFAULT
	boucleFPUcontrole:
	pop ecx
	loop @B
		;affiche le mode controle 
;	00	Round to nearest or even (Default)
;	01	Round down
;	10	Round up
;	11	Truncate

	xor eax,eax
	mov ax,controle
	and ax,0000110000000000b
	mov ecx,10
	shr ax,cl
	mov  etatround ,ax


FindeInterrogeFPUcontrole:
	ret
InterrogeFPUcontrole endp

;################################################################

InterrogeFPUetat PROC PRIVATE uses esi edi ebx
	Local controle:WORD
	Local BitTest:DWORD
	Local Pointe[10]:BYTE  ; 5
	FSTSW controle
	invoke RtlZeroMemory,addr phrase,sizeof phrase
	mov ecx,16	;begin by the last bit
	@@:
	push ecx
	dec  ecx    ;Numero du bit de 0 a 15 ecx - 1 = numero bit
	xor edx,edx
	mov dx,1
	rol dx,cl	;rotate 1 for mask  
	mov BitTest,edx
	pop ecx
	push ecx
	mov eax,ecx
	dec eax
	xor edx,edx
	mov ecx,4
	mul ecx	;ebx point to handle d'etiquette
	mov ebx,eax

	mov edx,BitTest

	test controle,dx
			;mask labels if bit n=0
		;Is this bit zero or not ?
		;Hetat dd 16 DUP(0) ,array of handle for to see state of bits				
		;stackfaut EtaTtexte3 (0 a 15) Hetat[12],eax bit 4
	.if !ZERO?
		mov edx,Hetat[ebx]         
		invoke ShowWindow,edx,SW_SHOWDEFAULT ;SW_HIDE	
	.else
		mov edx,Hetat[ebx]	
		invoke ShowWindow,edx,SW_HIDE ;SW_SHOWDEFAULT	
	.endif		
	;
	pop ecx
	loop @B			

	InsTxt   truc,"debugdata"
	;show the value of the stack pointer 
	movzx eax,controle
	and ax,0011100000000000b
	mov ecx,11
	shr ax,cl
	mov edx,eax
	.if edx != 0			;indique le nombre de data dans la pile,et non le pointeur
		mov eax,8
		sub eax,edx
		mov edx,eax
	.endif	
	invoke dwtoa,edx,addr Pointe
	lea esi,stackPoint
	lea edi,phrase
	mov ecx,sizeof stackPoint
	cld
	rep movsb 
	invoke szCatStr ,addr phrase, addr Pointe
	invoke SendMessage,HstackPoint,WM_SETTEXT,0,addr phrase
FindeInterrogeFPUetat:
	ret
InterrogeFPUetat endp

;################################################################

;################################################################
SauvePile PROC uses esi edi ebx Style:DWORD
	
	FNSAVE  SauveFpu   ;conserver l'etat + FINIT
	FRSTOR SauveFpu	;pour annuler FINIT
	call InterrogeFPUcontrole
	call InterrogeFPUetat
	FRSTOR SauveFpu
	FSTP FPUDATA0   ;decharger et sauver la pile de 7 nombres
	FSTP FPUDATA1   ;seul le registre 0 est interrogeable donc depiler FSTP et non FST
	FSTP FPUDATA2
	FSTP FPUDATA3   
	FSTP FPUDATA4   
	FSTP FPUDATA5   
	FSTP FPUDATA6   
	FSTP FPUDATA7		;suprime
	;---------------------------------------------------------------------------------
	.if Style == 0
		lea ebx,PrintfFloat0
	.elseif Style == 1
		lea ebx,PrintfFloat1	
	.elseif Style == 2
		lea ebx,PrintfFloat2	
	.elseif Style == 3
		lea ebx,PrintfFloat3
	.else
		lea ebx,PrintfFloat0	
	.endif
				
	;
	;show the registers
;PrintfFloat db "Real numbers:",13,10," %f %.2f %e ",0
;tampon db 100 dup(0)
;--------------- ou ---------------------------------
;	invoke FloatToStr,FPUDATA1,addr Affichage
;	call cherchezero
	invoke _finite,FPUDATA0
	push eax
	invoke _isnan,FPUDATA0
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
		NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA0	
	invoke SendMessage,Hedit0,WM_SETTEXT,0,addr Affichage	
	.else
		invoke SendMessage,Hedit0,WM_SETTEXT,0,NULL
	.endif
	;---------------------------------------------------------------------
	invoke _finite,FPUDATA1
	push eax	
	invoke _isnan,FPUDATA1
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA1		
		invoke SendMessage,Hedit1,WM_SETTEXT,0,addr Affichage	   
	.else
		invoke SendMessage,Hedit1,WM_SETTEXT,0,NULL
	.endif
	;-----------------------------------------------------------------------
	invoke _finite,FPUDATA2
	push eax	
	invoke _isnan,FPUDATA2
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA2	
	invoke SendMessage,Hedit2,WM_SETTEXT,0,addr Affichage
	.else
		invoke SendMessage,Hedit2,WM_SETTEXT,0,NULL
	.endif
	;------------------------------------------------------------------------
	invoke _finite,FPUDATA3
	push eax		
	invoke _isnan,FPUDATA3
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA3			   
	invoke SendMessage,Hedit3,WM_SETTEXT,0,addr Affichage	  
	.else
		invoke SendMessage,Hedit3,WM_SETTEXT,0,NULL
	.endif	 
	;------------------------------------------------------------------------
	invoke _finite,FPUDATA4
	push eax			
	invoke _isnan,FPUDATA4
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA4		
	invoke SendMessage,Hedit4,WM_SETTEXT,0,addr Affichage	   
	.else
		invoke SendMessage,Hedit4,WM_SETTEXT,0,NULL
	.endif	
	;------------------------------------------------------------------------
	invoke _finite,FPUDATA5
	push eax					
	invoke _isnan,FPUDATA5
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA5		
	invoke SendMessage,Hedit5,WM_SETTEXT,0,addr Affichage	
	.else
		invoke SendMessage,Hedit5,WM_SETTEXT,0,NULL
	.endif	
	;------------------------------------------------------------------------	   
	invoke _finite,FPUDATA6
	push eax				
	invoke _isnan,FPUDATA6
	pop edx
	.if eax == 0 && edx != 0
	invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 	NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA6		
	invoke SendMessage,Hedit6,WM_SETTEXT,0,addr Affichage	   
	.else
		invoke SendMessage,Hedit6,WM_SETTEXT,0,NULL
	.endif	
	;------------------------------------------------------------------------	
	invoke _finite,FPUDATA7
	push eax				
	invoke _isnan,FPUDATA7
	pop edx
	.if eax == 0 && edx != 0
		invoke StringCbPrintfEx,addr Affichage,sizeof Affichage,addr ppszDestEnd,
	 		NULL,STRSAFE_FILL_BEHIND_NULL,ebx,FPUDATA7		
		invoke SendMessage,Hedit7,WM_SETTEXT,0,addr Affichage
	.else
		invoke SendMessage,Hedit7,WM_SETTEXT,0,NULL
	.endif		
				
	;---------------------------------------------------------------------------------
	movzx eax,etatround
	.if eax == 3
		InsTxt   roundnear,"Rounding : TRUNCATE"
		invoke SendMessage,Hround,WM_SETTEXT,0,addr roundnear
	.elseif eax == 2
		InsTxt   roundup,"Rounding : UP "
		invoke SendMessage,Hround,WM_SETTEXT,0,addr roundup
	.elseif eax == 1
		InsTxt   rounddown,"Rounding : DOWN"
		invoke SendMessage,Hround,WM_SETTEXT,0,addr rounddown
	.else
		InsTxt   roundne,"Rounding : NEAREST or EVEN"	
		invoke SendMessage,Hround,WM_SETTEXT,0,addr roundne
	.endif


	FRSTOR SauveFpu

FindeSauvePile:

	ret
	;-----------------FINIT ----------------------------
;Sets the FPU control, status, tag, instruction pointer, and data pointer registers to their default
;states. The FPU control word is set to 037FH (round to nearest, all exceptions masked, 64-bit
;precision). The status word is cleared (no exception flags set, TOP is set to 0). The data registers
;in the register stack are left unchanged, but they are all tagged as empty (11B). Both the instruction
;and data pointers are cleared.
;screen value for empty = 11B  "-0.000000e+647"	
;si presque zero = 0,cherche la chaine ci dessus et la remplace par zero
cherchezero:
	push esi
	push edi
	mov ecx,sizeof PresqueZero -1 +1	;-1 len + zero; +1 for cmps that stop one before end
	lea esi,PresqueZero
	lea edi,Affichage	
	repz cmpsb
	.if ecx == 0
		invoke lstrcpy,addr Affichage,addr strzero	
		jmp finizero
	.endif
	mov ecx,sizeof PPresqueZero	
	lea esi,PPresqueZero
	lea edi,Affichage	
	repz cmpsb
	.if ecx == 0
		invoke lstrcpy,addr Affichage,addr strzero	
	.endif	
	finizero:
	pop edi
	pop esi
retn	
SauvePile endp

;################################################################
PourMille proc source:DWORD, permille:DWORD
;	 invoke   PourCent,Xresolution,80         ;80 % de Xresolution
	LOCAL var1:DWORD

	mov var1, 1000   ; to divide by 100
	FINIT		  ; l'instruction qui manque dans lib masm32
	fild source     ; load source integer
	fild var1       ; load 100
	fdiv            ; divide source by 100
	fild permille    ; load required percentage
	fmul            ; multiply 1% by required percentage
	fist var1       ; store result in variable
	mov eax, var1

	ret
PourMille endp
; #####################
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;################################################################

CreationBouton proc lpText:DWORD,PosX:DWORD,PosY:DWORD,Longueur:DWORD,Hauteur:DWORD,\
                       hWndParent:DWORD,Hmenu:DWORD
;Hmenu nombre dans WM_COMMAND .elseif wParam == Hmenu

     InsTxt  btnClass , "BUTTON"

; invoke CreationBouton,ADDR InsTxt,20,20,100,25,hWndParent,500

    invoke CreateWindowEx,0,
            ADDR btnClass,lpText,
            WS_CHILD or WS_VISIBLE,
            PosX,PosY,Longueur,Hauteur,hWndParent,Hmenu,hInstance,NULL

    ret

CreationBouton endp
; ########################################################################
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
end
; #########################################################################